import { DebounceExample } from './example';
import { ExampleFrame } from '@components';

## Using a closure
A closure is a self contained function that returns another function. In this case we can use a closure to create a debounce function and scope the timeout variable.

### Creating the closure

```javascript
/**
 * Creates a function that debounces the callback by the duration
 * @param {number} duration - The amount of time to wait before calling the callback
 * @param {function} callback - The function to be debounced
 * @returns {function} - A function that debounces the callback by the duration
 */
function makeDebounce(duration = 250, callback) {
  let timeout = null;

  /**
   * Sets or clears a timeout that runs a callback with the event value
   * @param {ChangeEvent} event - The event from an input change
   */
  function debounce(event) {
    if (timeout) clearTimeout(timeout);
    timeout = setTimeout(() =>
      callback(event.target.value),
    duration);
  }

  return debounce;
}

```

### Using the closure
To use this closure we need to call the `makeDebounce` function with our parameters, which will give us a debounce function for the parameters.
Then we need to assign it to something with a change event.

> **NOTE:**
> We can reuse the `debounce` variable name because it is scoped in the closure and doesn't exist in the global namespace yet.

```javascript
const debounce = makeDebounce(250, (value) => console.log(value));

document.querySelector('input').addEventListener('change', debounce);
```

#### Example (500ms timeout)
<ExampleFrame>
  <DebounceExample />
</ExampleFrame>
